'
'SI5351 VFO̎_18     2022. 9.24    JE1UCI
'------------------------------------------------------------------------------
$regfile = "attiny861.dat"
$crystal = 2000000                                          'kbc̕\x̂Ō


Config Porta = &B11110011
Config Portb = &B01100000
Porta = &B00001100
Portb = &B00010000

Config Lcdpin = Pin , Db4 = Porta.4 , Db5 = Porta.5
Config Lcdpin = Pin , Db6 = Porta.6 , Db7 = Porta.7
Config Lcdpin = Pin , E = Porta.1 , Rs = Porta.0
Config Lcd = 16 * 2
Config Adc = Single , Prescaler = Auto , Reference = Avcc

Config Scl = Portb.5
Config Sda = Portb.6

Dim Frq As Long
Dim Start_frq As Long
Dim Max_frq As Long
Dim Min_frq As Long
Dim Tempa As Byte
Dim Tempb As Byte
Dim Tempc As Byte
Dim Tempd As Long
Dim Tempe As Long
Dim Tempf As Single
Dim Tempg As Long
Dim Rena_flag As Byte
Dim Renb_flag As Byte
Dim Osc As Single
Dim Frqdata As String * 8
Dim Flaga As Byte
Dim Flagb As Byte

Dim Reg As Byte
Dim Dat As Byte

Dim Ap1 As Word
Dim Ap2 As Long
Dim Ap3 As Long

Dim Reg26 As Byte
Dim Reg27 As Byte
Dim Reg28 As Byte

Dim Reg29a As Byte
Dim Reg29 As Byte
Dim Reg29b As Byte

Dim Reg30 As Byte
Dim Reg31 As Byte
Dim Reg32 As Byte
Dim Reg33 As Byte


   Start_frq = 50620000                                     'dnm̎g
   Max_frq = 51000000                                       'őg
   Min_frq = 50000000                                       'ŏg
'------------------------------------------------------------------------------
Dataset:
   Frq = Start_frq
   I2cinit

   Waitms 500
   Gosub Si5351_set
   Gosub Si5351_frq
   Gosub Si5351


   Cls
   Waitms 500
   Locate 1 , 1
   Lcd "JE1UCI Si5351VFO"
   Cursor Off
   Gosub Dspfrq
    Tempa = Pina
        Tempa = Tempa And &H0C
    Flaga = Tempa

'------------------------------------------------------------------------------
Main:

If Pinb.4 = 1 Then
   Goto Main_rena1
      End If

Main_rena:
   Gosub Rena
       Select Case Rena_flag
          Case 1 : Goto Main_dn
          Case 2 : Goto Main_up
          Case Else : Goto Main_end
               End Select
Main_up:
   Rena_flag = 0
   Tempa = 100
   Frq = Frq + Tempa
   Gosub Maxchk
   Goto Main_lcd
Main_dn:
   Rena_flag = 0
   Tempa = 100
   Frq = Frq - Tempa
   Gosub Minchk
   Goto Main_lcd

Main_rena1:
   Gosub Rena
       Select Case Rena_flag
          Case 1 : Goto Main_dn1k
          Case 2 : Goto Main_up1k
          Case Else : Goto Main_end
               End Select

Main_up1k:
   Rena_flag = 0
   Tempd = 1000
   Frq = Frq + Tempd
   Gosub Maxchk
   Goto Main_lcd
Main_dn1k:
   Rena_flag = 0
   Tempd = 1000
   Frq = Frq - Tempd
   Gosub Minchk
   Goto Main_lcd

Main_lcd:
   Gosub Dspfrq
Main_si5351:
   Gosub Si5351_frq
   Gosub Si5351
Main_end:
   Goto Main
   End
'------------------------------------------------------------------------------
'ȉTu[`
'------------------------------------------------------------------------------
Rena:
   Tempa = Pina
        Tempa = Tempa And &H0C
   Select Case Flaga
      Case &H00 : Goto Rena_0
      Case &H04 : Goto Rena_1
      Case &H08 : Goto Rena_2
      Case &H0C : Goto Rena_3
      Case Else : Goto Rena_end
         End Select
Rena_0:
   Select Case Tempa
      Case &H00 : Goto Rena_end
      Case &H04 : Goto Rena_up
      Case &H08 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select
Rena_1:
   Select Case Tempa
      Case &H04 : Goto Rena_end
      Case &H0C : Goto Rena_up
      Case &H00 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select
Rena_2:
    Select Case Tempa
      Case &H08 : Goto Rena_end
      Case &H00 : Goto Rena_up
      Case &H0C : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select
Rena_3:
   Select Case Tempa
      Case &H0C : Goto Rena_end
      Case &H08 : Goto Rena_up
      Case &H04 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select
Rena_up:
   Rena_flag = 1
   Goto Rena_end
Rena_dn:
   Rena_flag = 2
Rena_end:
   Flaga = Tempa


   Locate 2 , 1
   Lcd Rena_flag

   Lcd " "

   Return
'------------------------------------------------------------------------------


'------------------------------------------------------------------------------
Dspfrq:
   Locate 2 , 3
   Frqdata = Str(frq)
   Select Case Frq
      Case Is >= 10000000 : Goto Dspfrq_lcd7                '10MHz
      Case Is >= 1000000 : Goto Dspfrq_lcd6                 '1MHz
      Case Is >= 100000 : Goto Dspfrq_lcd5                  '100kHz
      Case Is >= 10000 : Goto Dspfrq_lcd4                   '10kHz
      Case Is >= 1000 : Goto Dspfrq_lcd3                    '1kHz
      Case Is >= 100 : Goto Dspfrq_lcd2                     '100Hz
      Case Is >= 10 : Goto Dspfrq_lcd1                      '10Hz
   End Select
Dspfrq_lcd7:
   Lcd Left(frqdata , 2) : Lcd "." : Lcd Mid(frqdata , 3 , 3) : Lcd "," : Lcd Mid(frqdata , 6 , 1) : Lcd "MHz"       'Ō6,2ύX10HzJbg
   Return
Dspfrq_lcd6:
   Lcd " " : Lcd Left(frqdata , 1) : Lcd "." : Lcd Mid(frqdata , 2 , 3) : Lcd "," : Lcd Mid(frqdata , 5 , 2) : Lcd "MHz "
   Return
Dspfrq_lcd5:
   Lcd "   " : Lcd Left(frqdata , 3) : Lcd "." : Lcd Mid(frqdata , 4 , 2) : Lcd "kHz "
   Return
Dspfrq_lcd4:
   Lcd "    " : Lcd Left(frqdata , 2) : Lcd "." : Lcd Mid(frqdata , 3 , 2) : Lcd "kHz "
   Return
Dspfrq_lcd3:
   Lcd "     " : Lcd Left(frqdata , 1) : Lcd "." : Lcd Mid(frqdata , 2 , 2) : Lcd "kHz "
   Return
Dspfrq_lcd2:
   Lcd "       " : Lcd Left(frqdata , 3) : Lcd "Hz"
   Return
Dspfrq_lcd1:
   Lcd "        " : Lcd Left(frqdata , 2) : Lcd "Hz"
   Return
'------------------------------------------------------------------------------
Si5351_frq:
   Tempe = Frq - 49999200                                   '50000000{̒lł邪
   Tempe = Tempe / 100
   Tempe = Tempe * 48
   Tempe = Tempe * 128
   Tempf = Tempe / 1000000
   Tempf = Int(tempf)

   Ap1 = Tempf + 2560
   Tempg = Tempf * 1000000
   Ap2 = Tempe - Tempg
   Ap3 = 1000000

   Locate 1 , 1
   Lcd "                "
   Locate 1 , 1
   Lcd Ap1
   Locate 1 , 8
   Lcd Ap2

   Reg27 = Low(ap3)
   Shift Ap3 , Right , 8
   Reg26 = Low(ap3)

   Reg30 = Low(ap1)
   Shift Ap1 , Right , 8
   Reg29 = Low(ap1)

   Shift Ap1 , Right , 8
   Reg28 = Low(ap1)

   Reg33 = Low(ap2)
   Shift Ap2 , Right , 8
   Reg32 = Low(ap2)

   Shift Ap2 , Right , 8
   Reg31 = Low(ap2)
   Shift Ap3 , Right , 8
   Shift Ap3 , Left , 4
   Reg31 = Reg31 Or Ap3

   Return
'------------------------------------------------------------------------------
Si5351:
   Reg = 26                                                 'MSNA_P3 (15:8)
   Dat = Reg26
   Gosub Si5351_send
   Reg = 27                                                 'MSNA_P3 (7:0)
   Dat = Reg27
   Gosub Si5351_send

   Reg = 28                                                 'MSNA_P1 (17:16)
   Dat = Reg28
   Gosub Si5351_send
   Reg = 29                                                 'MSNA_P1 (15:8)
   Dat = Reg29
   Gosub Si5351_send
   Reg = 30                                                 'MSNA_P1 (7:0)
   Dat = Reg30
   Gosub Si5351_send

   Reg = 31                                                 'MSNA_P3 (19:16) MSNA_P2 (19:16)
   Dat = Reg31
   Gosub Si5351_send

   Reg = 32                                                 'MSNA_P2 (15:8)
   Dat = Reg32
   Gosub Si5351_send
   Reg = 33                                                 'MSNA_P2 (7:0)
   Dat = Reg33
   Gosub Si5351_send

   Reg = 42                                                 'MS0_P3 (15:8)
   Dat = &H00
   Gosub Si5351_send
   Reg = 43                                                 'MS0_P3 (7:0)
   Dat = &H01
   Gosub Si5351_send

   Reg = 44                                                 'MS0_P1 (17:16)
   Dat = &H00
   Gosub Si5351_send
   Reg = 45                                                 'MS0_P1 (15:8)
   Dat = &H04
   Gosub Si5351_send
   Reg = 46                                                 'MS0_P1 (7:0)
   Dat = &H00
   Gosub Si5351_send

   Reg = 47                                                 'MS0_P3 (19:16)   MS0_P2 (19:16)
   Dat = &H00
   Gosub Si5351_send

   Reg = 48                                                 'MS0_P2 (15:8)
   Dat = &H00
   Gosub Si5351_send
   Reg = 49                                                 'MS0_P2 (7:0)
   Dat = &H00
   Gosub Si5351_send

   Reg = 177
   Dat = &HA0

   Reg = 16
   Dat = &H4F

   Reg = 3
   Dat = &HFE

   Return

'------------------------------------------------------------------------------
Si5351_set:
   Reg = 3
   Dat = &HFE
   Gosub Si5351_send
   Reg = 16
   Dat = &H4F
   Gosub Si5351_send
   Reg = 17
   Dat = &H80
   Gosub Si5351_send
   Reg = 18
   Dat = &H80
   Gosub Si5351_send

   Reg = 177
   Dat = &HA0
   Gosub Si5351_send

   Reg = 183
   Dat = &H80
   Gosub Si5351_send

   Return

'-----------------------
Si5351_send:
   I2cstart

   I2cwbyte &HC0
   Waitus 1
   I2cwbyte Reg
   Waitus 1
   I2cwbyte Dat

   I2cstop
   Return
'------------------------------------------------------------------------------
Minchk:
   If Frq < Min_frq Then
     Frq = Min_frq
        End If
   Return
'------------------------------------------------------------------------------
Maxchk:
   If Frq > Max_frq Then
   Frq = Max_frq
     End If
   Return
'------------------------------------------------------------------------------
   End